<?php
	require 'tmp/sql.php';
	require 'classes/mysql.php';
	
	$sql = new MySQL(); if ($sql->debug) error_reporting (E_ALL|E_STRICT); else error_reporting (0);
	
	require 'plugins/phpQuery.php';
	require 'classes/settings.php';
	require 'classes/security.php';
	require 'classes/functions.php';
	require 'classes/session.php';
	require 'classes/template.php';
	require 'classes/player.php';
	require 'classes/stats.php';
	require 'classes/server.php';
	require 'classes/rcon.php';
	
	$secure   = new Security();
	$settings = new Settings();
	$stats    = new Stats();
	$server   = new Server();
	$tpl = new Templates();
	$tpl->load_phrases("gui", true);
	$tpl->load_phrases("admin", true);
	$tpl->load_phrases("_serv", true);
	
	
	
	### STANDARDS EINSTELLEN ###
	date_default_timezone_set($settings->get("timezone")); // Zeitzone
	$path = ($settings->get("cms") == "standalone") ? "" : $settings->get("path");
	
	// bergebene Werte
	if (isset($_POST['action'])) $action = $_POST['action']; else $action = NULL;
	if (isset($_POST['target'])) $target = $_POST['target']; else $target = NULL;
	if (isset($_POST['id']))     $id     = $_POST['id'];     else $id     = NULL;
	
	
	
	### INFOBEREICH ###
	if ($action == "infoarea") {
		$server->set($id);
		$server->get();
		
		// Daten sind vorhanden
		if ($server->error === false) {
			// Variablen einstellen
			$info = $server->info;
			
			$servername = ($server->name != "") ? $server->name : $info->name;
			$platform   = $stats->form($info->plat, Array('deficon', 'platform'));
			$ctysrc     = ($server->platform == "pc") ? $path.'stylesheets/images/flags/'.strtolower($info->country).'.png' : $path.'stylesheets/images/flags/none.png';
			$mapsrc     = $path.'stylesheets/images/maps_l/'.$server->game.'/'.$info->map_image.'.jpg';
			$ip         = $info->ip.":".$info->port;
			$pb         = $info->pb ? $tpl->phrase("on") : $tpl->phrase("off");
			$pw         = $info->pw ? $tpl->phrase("on") : $tpl->phrase("off");
			
			$set        = $info->settings;
			$set->region = '<span title="'.$info->country_name.' ('.$info->region.')"><img src="'.$ctysrc.'" />';
			$set->serveradress = '<span title="'.$ip.'">&otimes;</span>';
			$i          = 1;
			$tr         = "";
			$forbidden = Array('vrtm', 'gmwp', 'vpst', 'vcrl', 'agjo', 'vvsd', 'ulsb', 'vumc', 'vgmc', 'vtkv', 'vrrp', 'vmpl', 'essr', 'vrlc', 'vsna', 'vrsp', 'vhbi', 'vhha', 'vhmn', 'vhpt', 'vhet', 'vhch', 'vhei', 'vhca', 'vhgm', 'vhob', 'vhul', 'vbdo');
			
			foreach ($set as $key => $value) {
				if (!in_array($key, $forbidden)) {
					if ($i == 1) $tr .= "<tr>";
						
					if (is_bool($value)) {
						if ($value == 1) 	$result = $tpl->phrase("on");
						else 				$result = $tpl->phrase("off");
					} else {
						$result = $value;
					}
					
					$tr .= '<td>'.$tpl->phrase($key).'</td><td>'.$result.'</td>';
					
					if ($i == 3) { $tr .= "</tr>"; $i = 0; }
					$i++;
				}
			}
			
			$html = "";
			if ($settings->get("serv_infoheader")) eval ("\$html .= \"".$tpl->template("infoarea")."\";");
			if ($settings->get("serv_settings"))   eval ("\$html .= \"".$tpl->template("serversettings")."\";");  
			
			die (json_encode(array(
				//"message" => $info->settings,
				"target"  => $target,
				"html"    => $html
			)));
		} 
		
		// Es sind keine Daten vorhanden
		else {
			if ($server->error == "no_connection") {
				die (json_encode(array(
					"message" => $server->message,
					"target"  => $target,
					"html"    => "<p>".$tpl->phrase("message_battlelog_offline")."</p>"
				)));
			}
			if ($server->error == "not_found") {
				die (json_encode(array(
					"message" => $server->message,
					"target"  => $target,
					"html"    => "<p>".$tpl->phrase("message_check_id_notfound")."</p>"
				)));
			}
		}
	}
	
	
	
	### SERVERBESCHREIBUNG ###
	if ($action == "description") {
		$server->set($id);
		$server->get();
		
		// Daten sind vorhanden
		if ($server->error === false) {
			// Variablen einstellen
			if ($server->game == "bf3") {
				$desctxt   = ($server->desc == "") ? str_replace("|", "<br/>", $server->info->desc) : nl2br($server->desc); // Custom-Serverbeschreibung wenn vorhanden, ansonsten Serverbeschreibung aus der Config
				$descimg   = substr($server->info->burl, 0, 4) == "http" ? '<img src="'.$server->info->burl.'" /><br />' : "";
				$battlelog = $server->info->battlelog;
				$bf3stats  = 'http://www.bf3stats.com/server/'.$server->info->plat.'_'.$server->info->id;
			} else if ($server->game == "mohw") {
				$desctxt   = nl2br($server->desc); // Serverbeschreibung aus der Config
				$descimg   = "";
				$battlelog = $server->info->battlelog;
				$bf3stats  = 'http://www.mohwstats.com/server/'.$server->info->plat.'_'.$server->info->id;
			}
			
			// Template erstellen
			eval ("\$html = \"".$tpl->template("description")."\";");
			$html = phpQuery::newDocumentHTML($html);
			
			// Elemente ausblenden wenn ntig
			if ($descimg == "" AND trim($desctxt) == "") {
				pq('span')->remove(); // Beschreibung ausblenden
			} else if (!$settings->get("serv_description")) {
				pq('span')->remove(); // Beschreibung ausblenden
			}
			
			if (!$settings->get("serv_battlelog_url")) {
				pq('a')->remove(); // Battelog- und BF3Stats-Link ausblenden
			}
			
			if ($server->platform != "pc") {
				pq('a:eq(0)')->remove(); // Battelog-Link ausblenden fr Konsolen
			}
			
			
			die (json_encode(array(
				//"message" => $server->info,
				"target"  => $target,
				"html"    => $html->__toString()
			)));
		} 
		
		// Es sind keine Daten vorhanden
		else {
			die (json_encode(array(
				"target"  => $target,
				"html"    => "&nbsp"
			)));
		}
	}
	
	
	
	### MAPCYCLE ###
	if ($action == "mapcycle") {
		$server->set($id);
		$server->get();
		
		// Daten sind vorhanden
		if ($server->error === false) {
			// Variablen einstellen
			$maps    = $server->info->maps;
			$startID = 1;
			$img     = "";
			
			for ($i = 0; $i < count($maps); $i++) {
				if (strtolower($maps[$i]->map_image) == strtolower($server->info->map_image)) $startID = $i+1;
				
				$img .= '<img src="'.$path.'stylesheets/images/maps_m/'.$server->game.'/'.strtolower($maps[$i]->map_image).'.jpg" width="146" height="79" title="'.($maps[$i]->map_name).htmlspecialchars("<br/>").($maps[$i]->mode_name).'" />';
			}
			
			eval ("\$html = \"".$tpl->template("mapcycle")."\";");
			
			die (json_encode(array(
				//"message" => $img,
				"target"  => $target,
				"html"    => $html
			)));
		} 
		
		// Es sind keine Daten vorhanden
		else {
			die (json_encode(array(
				"target"  => $target,
				"html"    => "&nbsp"
			)));
		}
	}
	
	
	
	### SCORETABLE ###
	if ($action == "scoretable") {
		$server->set($id);
		$server->live();
		$html = " ";
		
		// Server ist online
		if ($server->online) $html = $server->score;
		
		die (json_encode(array(
			//"message" => $server->round,
			"target"  => $target,
			"html"    => $html
		)));
	}
	
	
	
	### SERVERSTATS ###
	if ($action == "serverstats") {
		$server->set($id);
		$tpl->load_phrases("detail", true);
		$tpl->load_phrases("overview", true);
		$html = " ";
		
		
		if ($server->fetch['procon_show'] OR $server->fetch['xlrstats_show']) {
			// PROCON
			if ($server->fetch['procon_show']) {
				$sq2 = new MySQL('{"debug": "'.$sql->debug.'", "sqldb": "'.$server->fetch['procon_sqldb'].'", "sqlhost": "'.$server->fetch['procon_sqlhost'].'", "sqluser": "'.$server->fetch['procon_sqluser'].'", "sqlpwd": "'.$server->fetch['procon_sqlpwd'].'", "prefix": "'.$server->fetch['procon_prefix'].'"}');
				$sq2->query('
					SELECT *
					FROM '.$sq2->prefix.'server_player i
					JOIN '.$sq2->prefix.'playerdata p
						ON i.PlayerID = p.PlayerID
					JOIN '.$sq2->prefix.'playerstats s
						ON i.StatsID = s.StatsID
					WHERE
						i.ServerID = '.$server->fetch['procon_servid'].'
					ORDER BY
						s.score DESC
				');
				
				$count = $server->fetch['procon_count'] < $sq2->count() ? $server->fetch['procon_count'] : $sq2->count();
				$url = $server->fetch['procon_url'];
				$tr = "";
				
				for ($i = 0; $i < $count; $i++) {
					$row = $sq2->fetchRow();
					
					// KDR
					$k = $row['Kills'] == 0 ? 1 : $row['Kills'];
					$d = $row['Deaths'] == 0 ? 1 : $row['Deaths'];
					$kdr = round(($k/$d), 1);
					
					$tr .= '<tr>';
					
					$result = $stats->form($i+1, Array('number', 0, '', 'position'));
					$tr .= '<td sort="'.$result['sort'].'" title="'.$result['tip'].'">'.$result['format'].'</td>';
					
					$result = $stats->form($row['CountryCode'], Array('deficon', 'country'));
					$tr .= '<td sort="'.$row['SoldierName'].'" class="tleft">'.$result['format'].' <a href="http://battlelog.battlefield.com/bf3/user/'.$row['SoldierName'].'" target="_blank">'.$row['SoldierName'].'</a></td>';
					
					$result = $stats->form($row['Score'], Array('number', 0, "", "score"));
					$tr .= '<td sort="'.$result['sort'].'" title="'.$result['tip'].'">'.$result['format'].'</td>';
					
					$result = $stats->form($row['Playtime'], Array('time', 0, 'h'));
					$tr .= '<td sort="'.$result['sort'].'" title="'.$result['tip'].'">'.$result['format'].'</td>';
					
					$result = $stats->form($row['Kills'], Array('number', 0, '', 'kills'));
					$tr .= '<td sort="'.$result['sort'].'" title="'.$result['tip'].'">'.$result['format'].'</td>';
					
					$result = $stats->form($row['Deaths'], Array('number', 0, '', 'deaths'));
					$tr .= '<td sort="'.$result['sort'].'" title="'.$result['tip'].'">'.$result['format'].'</td>';
					
					$result = $stats->form($row['Kills'], Array('ratio', $row['Deaths'], 2, '', 'kdr'));
					$tr .= '<td sort="'.$result['sort'].'" title="'.$result['tip'].'">'.$result['format'].'</td>';
					
					$result = $stats->form($row['Score'], Array('ratio', ($row['Playtime']/60), 0, '', 'spm'));
					$tr .= '<td sort="'.$result['sort'].'" title="'.$result['tip'].'">'.$result['format'].'</td>';
					
					$result = $stats->form($row['Score'], Array('ratio', $row['Rounds'], 0));
					$tr .= '<td sort="'.$result['sort'].'" title="'.$tpl->phrase("spr_desc").': '.$result['tip'].'">'.$result['format'].'</td>';
					
					$result = $stats->form($row['Rounds'], Array('number', 0));
					$tr .= '<td sort="'.$result['sort'].'" title="'.$tpl->phrase("roundsplayed").': '.$result['tip'].'">'.$result['format'].'</td>';
					
					$result = $stats->form($row['Killstreak'], Array('number', 0));
					$tr .= '<td sort="'.$result['sort'].'" title="'.$tpl->phrase("killstreakbonus").': '.$result['tip'].'">'.$result['format'].'</td>';
					
					$tr .= '</tr>';
				}
				
				eval ("\$html = \"".$tpl->template("srvstats_pcon")."\";");
			}
			
			// XLRSTATS
			if ($server->fetch['xlrstats_show']) {
				$sq2 = new MySQL('{"debug": "'.$sql->debug.'", "sqldb": "'.$server->fetch['xlrstats_sqldb'].'", "sqlhost": "'.$server->fetch['xlrstats_sqlhost'].'", "sqluser": "'.$server->fetch['xlrstats_sqluser'].'", "sqlpwd": "'.$server->fetch['xlrstats_sqlpwd'].'", "prefix": "'.$server->fetch['xlrstats_prefix'].'"}');
				$sq2->query('
					SELECT *
					FROM '.$sq2->prefix.'xlr_playerstats s
					JOIN '.$sq2->prefix.'clients c
						ON s.client_id = c.id
					WHERE
						`hide` = 0
					ORDER BY
						s.skill DESC
				');
				
				$count = $server->fetch['xlrstats_count'] < $sq2->count() ? $server->fetch['xlrstats_count'] : $sq2->count();
				$url = $server->fetch['xlrstats_url'];
				$tr = "";
				
				for ($i = 0; $i < $count; $i++) {
					$row = $sq2->fetchRow();
					
					// KDR
					$k = $row['kills'] == 0 ? 1 : $row['kills'];
					$d = $row['deaths'] == 0 ? 1 : $row['deaths'];
					$kdr = round(($k/$d), 1);
					
					$tr .= '<tr>';
					
					$result = $stats->form($i+1, Array('number', 0, '', 'position'));
					$tr .= '<td sort="'.$result['sort'].'" title="'.$result['tip'].'">'.$result['format'].'</td>';
					
					$tr .= '<td sort="'.$row['name'].'" class="tleft"><a href="http://battlelog.battlefield.com/bf3/user/'.$row['name'].'" target="_blank">'.$row['name'].'</a></td>';
					
					$result = $stats->form($row['kills'], Array('number', 0, '', 'kills'));
					$tr .= '<td sort="'.$result['sort'].'" title="'.$result['tip'].'">'.$result['format'].'</td>';
					
					$result = $stats->form($row['deaths'], Array('number', 0, '', 'deaths'));
					$tr .= '<td sort="'.$result['sort'].'" title="'.$result['tip'].'">'.$result['format'].'</td>';
					
					$result = $stats->form($row['kills'], Array('ratio', $row['deaths'], 2, '', 'kdr'));
					$tr .= '<td sort="'.$result['sort'].'" title="'.$result['tip'].'">'.$result['format'].'</td>';
					
					$result = $stats->form($row['skill'], Array('number', 0, '', 'skill'));
					$tr .= '<td sort="'.$result['sort'].'" title="'.$result['tip'].'">'.$result['format'].'</td>';
					
					$result = $stats->form($row['rounds'], Array('number', 0));
					$tr .= '<td sort="'.$result['sort'].'" title="'.$tpl->phrase("roundsplayed").': '.$result['tip'].'">'.$result['format'].'</td>';
					
					$result = $stats->form($row['winstreak'], Array('number', 0));
					$tr .= '<td sort="'.$result['sort'].'" title="'.$tpl->phrase("killstreakbonus").': '.$result['tip'].'">'.$result['format'].'</td>';
					
					$tr .= '</tr>';
				}
				
				eval ("\$html = \"".$tpl->template("srvstats_xlr")."\";");
			}
		}
		
		
		die (json_encode(array(
			//"message" => $server->fetch,
			"target"  => $target,
			"html"    => $html
		)));
	}
?>