<?php
	require '../tmp/sql.php';
	require '../classes/mysql.php';
	
	$sql = new MySQL(); if ($sql->debug) error_reporting (E_ALL|E_STRICT); else error_reporting (0);
	
	require '../plugins/phpQuery.php';
	require '../classes/settings.php';
	require '../classes/security.php';
	require '../classes/functions.php';
	require '../classes/session.php';
	require '../classes/login.php';
	require '../classes/template.php';
	require '../classes/server.php';
	require '../classes/rcon.php';
	
	$secure   = new Security();
	$settings = new Settings();
	$server   = new Server();
	$login    = new Login(Session::getSID());
	$tpl      = new Templates();
	$tpl->load_phrases("gui", true);
	$tpl->load_phrases("admin", true);
	$tpl->load_phrases("_serv", true);
	
	
	
	### LOGIN-PRFUNG // STANDARDS ###
	if(!$login->logged_in()) {
		// User ist nicht eingeloggt -> Fehlermeldung
		die (json_encode(array(
			"message" => "Error: Please login to perform this action!",
			"href" => "index.php"
		)));
	}
	else {
		### STANDARDS EINSTELLEN ###
		// Zeitzone
		date_default_timezone_set($settings->get("timezone"));
		
		// Userinformationen
		$sql->query('SELECT * FROM '.$sql->prefix.'users WHERE session = "'.$_POST['sid'].'"');
		$user = $sql->fetchRow();
		
		// bergebene Werte
		if (isset($_POST['action'])) $action = $_POST['action']; else $action = "";
		if (isset($_POST['sid']))    $sid = $_POST['sid'];       else $sid = "";
		if (isset($_POST['input']))  $input = $_POST['input'];   else $input = "";
	}
	
	
	### RCON-FORMULAR ###
	if ($action == "rcon_form") {
		$server->set($input);
		
		
		// Lademeldung
		$name = $server->name;
		eval ("\$message = \"".$tpl->phrase("rcon_loading_message")."\";");
		
		
		// Mit dem RCON-Server verbinden wenn alle Daten vorhanden sind
		if (!$server->ip OR !$server->port OR !$server->password) {//if (false) {//
			// Nicht alle RCON-Daten vorhanden
			$html = '
				<h3>'.$tpl->phrase("message_check_rcon_notconnected").'</h3>
				<p>'.$tpl->phrase("rcon_no_data").'</p>
			';
			
			if ($user['adminpower'] == "1") $html .= '<p><a class="" href="index.php?add&amp;sid='.$sid.'&amp;edit='.$input.'">'.$tpl->phrase("nav_editserver").'</a></p>';
			
			die (json_encode(array(
				"message"  => $message,
				"serverid" => $input,
				"html"     => $html
			)));
		} else {
			// Alle RCON-Daten vorhanden -> mit dem Server verbinden
			$rcon = new BF3Conn($server->ip, $server->port); 
		}
		
		
		// Als Admin mit Passwort einloggen, wenn Verbindung hergestellt wurde
		if (!$rcon->isConnected()) {
			// IP oder Port fehlerhaft
			$html = '
				<h3>'.$tpl->phrase("message_check_rcon_notconnected").'</h3>
				<p>'.$tpl->phrase("rcon_error_ip_port").'</p>
			';
			
			if ($user['adminpower'] == "1") $html .= '<p><a class="" href="index.php?add&amp;sid='.$sid.'&amp;edit='.$input.'">'.$tpl->phrase("nav_editserver").'</a></p>';
			
			die (json_encode(array(
				"message"  => $message,
				"serverid" => $input,
				"html"     => $html
			)));
		} else {
			// Verbindung zum Server ist hergestellt -> Mit Passwort einloggen
			$rcon->loginSecure($server->password);
		}
		
		
		// RCON-Formular ausgeben, wenn das Passwort korrekt war
		if (!$rcon->isLoggedIn()) { //if (false) {//
			// Passwort ist fehlerhaft
			$html = '
				<h3>'.$tpl->phrase("message_check_rcon_notconnected").'</h3>
				<p>'.$tpl->phrase("rcon_error_password").'</p>
			';
			
			if ($user['adminpower'] == "1") $html .= '<p><a class="" href="index.php?add&amp;sid='.$sid.'&amp;edit='.$input.'">'.$tpl->phrase("nav_editserver").'</a></p>';
		} else {
			// Alle Daten korrekt -> Formular ausgeben
			$server->live("admin");
			$round = $server->round;
			
			eval ("\$html = \"".$tpl->template("rcon_form")."\";");  
			$html = phpQuery::newDocumentHTML($html);
			
			// Message-Box ausblenden bei MoHW
			if ($server->game == "mohw") pq('#ezMessage')->attr("style", "display:none");
			
			$html = $html->__toString();
		}
		
		
		die (json_encode(array(
			"message"  => $message,
			"serverid" => $input,
			"html"     => $html
		)));
	}
	
	
	### RCON-BEFEHLE ###
	if ($action == "rcon_command") {
		// RCON-Befehl ausfhren
		$server->set($input['serverid']);
		$server->command($input['command'], $input['nextmap'], $input['name'], $input['message']);
		//print_r($input);
		
		// Aktuelle Daten laden
		sleep(1);
		$server->live("admin");
		
		die (json_encode(array(
			"mapname"  => $server->mapname,
			"playmode" => $server->playmode,
			"round"    => $server->rounds,
			"score"    => $server->score
		)));
	}
	
	
	### SERVER-ID TESTEN ###
	if ($action == "check_id") {
		$info = $server->loadAPI($input['serverid'], $input['platform'], $input['game']);
		
		if ($info) {
			die (json_encode(array( 
				"message" => $tpl->phrase("message_check_id_found"),
				"button"  => $tpl->phrase("ok"),
				"action"  => "check_id",
				"name"    => $server->info->name,
				"ip"      => $server->info->ip
			)));
		}
		else {
			if ($server->error == "no_connection") {
				die (json_encode(array(
					"message" => $tpl->phrase("message_battlelog_offline"),
					"button"  => $tpl->phrase("error")
				)));
			}
			if ($server->error == "not_found") {
				die (json_encode(array(
					"message" => $tpl->phrase("message_check_id_notfound"),
					"button"  => $server->message
				)));
			}
		} 
	}
	
	
	### SERVER-IP TESTEN ###
	if ($action == "check_rcon") {
		$rcon = new BF3Conn($input['ip'], $input['port']);
		
		if ($rcon->isServerOnline()) {
			die (json_encode(array(
				"message" => $tpl->phrase("message_check_rcon_connected"),
				"button" => $tpl->phrase("ok")
			)));
		} else {
			die (json_encode(array(
				"error" => "true",
				"message" => $tpl->phrase("message_check_rcon_notconnected").$rcon->_error,
				"button" => $tpl->phrase("error")
			)));
		}
	}
	
	
	### SERVER-PASSWORT TESTEN ###
	if ($action == "check_password") {
		$rcon = new BF3Conn($input['ip'], $input['port']);
		
		if ($rcon->isServerOnline()) {
			$result = $rcon->loginSecure($input['password']);
			
			if ($result == "OK") {
				die (json_encode(array( 
					"message" => $tpl->phrase("message_check_rcon_connected"),
					"button" => $tpl->phrase("ok")
				)));
			} else {
				die (json_encode(array(
					"message" => $tpl->phrase("message_check_rcon_notconnected"),
					"button" => $tpl->phrase("error")
				)));
			}
		} else {
			die (json_encode(array(
				"message" => $tpl->phrase("message_check_rcon_notconnected"),
				"button" => $tpl->phrase("error")
			)));
		}
	}
	
	
	### SERVER HINZUFGEN ###
	if ($action == "add_server") {
		if ($user['adminpower'] != "1") die (json_encode(array("message" => "Error: You have not the required rights to perform this action")));
		
		if ($input['id']) {
			// Bestehenden Server ndern
			$sql->query('
				UPDATE 
					'.$sql->prefix.'server 
				SET 
					`name`        = "'.$input['name'].'",
					`description` = "'.$input['serverdesc'].'",
					`serverid`    = "'.$input['serverid'].'",
					`game`        = "'.$input['game'].'",
					`platform`    = "'.$input['platform'].'",
					`ip`          = "'.$input['ip'].'",
					`port`        = "'.$input['port'].'",
					`password`    = "'.$input['password'].'",
					`procon_show`    = "'.$input['procon_show'].'",
					`procon_count`   = "'.$input['procon_count'].'",
					`procon_servid`  = "'.$input['procon_servid'].'",
					`procon_url`     = "'.$input['procon_url'].'",
					`procon_sqlhost` = "'.$input['procon_sqlhost'].'",
					`procon_sqldb`   = "'.$input['procon_sqldb'].'",
					`procon_sqluser` = "'.$input['procon_sqluser'].'",
					`procon_sqlpwd`  = "'.$input['procon_sqlpwd'].'",
					`procon_prefix`  = "'.$input['procon_prefix'].'",
					`xlrstats_show`    = "'.$input['xlrstats_show'].'",
					`xlrstats_count`   = "'.$input['xlrstats_count'].'",
					`xlrstats_url`     = "'.$input['xlrstats_url'].'",
					`xlrstats_sqlhost` = "'.$input['xlrstats_sqlhost'].'",
					`xlrstats_sqldb`   = "'.$input['xlrstats_sqldb'].'",
					`xlrstats_sqluser` = "'.$input['xlrstats_sqluser'].'",
					`xlrstats_sqlpwd`  = "'.$input['xlrstats_sqlpwd'].'",
					`xlrstats_prefix`  = "'.$input['xlrstats_prefix'].'"
				WHERE 
					`id` = "'.$input['id'].'"
			');
		} else {
			// Neuen Server hinzufgen
			
			$sql->query('SELECT `order` FROM '.$sql->prefix.'server ORDER BY `order` DESC');
			$order = $sql->count() ? $sql->fetchRow("order")+1 : 1;
			
			$sql->query('
				INSERT INTO '.$sql->prefix.'server (
					`name`,
					`description`,
					`serverid`,
					`game`,
					`platform`,
					`ip`,
					`port`,
					`password`,
					`order`,
					`procon_show`,
					`procon_count`,
					`procon_servid`,
					`procon_url`,
					`procon_sqlhost`,
					`procon_sqldb`,
					`procon_sqluser`,
					`procon_sqlpwd`,
					`procon_prefix`,
					`xlrstats_show`,
					`xlrstats_count`,
					`xlrstats_url`,
					`xlrstats_sqlhost`,
					`xlrstats_sqldb`,
					`xlrstats_sqluser`,
					`xlrstats_sqlpwd`,
					`xlrstats_prefix`
				) VALUES (
					"'.$input['name'].'",
					"'.$input['serverdesc'].'",
					"'.$input['serverid'].'",
					"'.$input['game'].'",
					"'.$input['platform'].'",
					"'.$input['ip'].'",
					"'.$input['port'].'",
					"'.$input['password'].'",
					"'.$order.'",
					"'.$input['procon_show'].'",
					"'.$input['procon_count'].'",
					"'.$input['procon_servid'].'",
					"'.$input['procon_url'].'",
					"'.$input['procon_sqlhost'].'",
					"'.$input['procon_sqldb'].'",
					"'.$input['procon_sqluser'].'",
					"'.$input['procon_sqlpwd'].'",
					"'.$input['procon_prefix'].'",
					"'.$input['xlrstats_show'].'",
					"'.$input['xlrstats_count'].'",
					"'.$input['xlrstats_url'].'",
					"'.$input['xlrstats_sqlhost'].'",
					"'.$input['xlrstats_sqldb'].'",
					"'.$input['xlrstats_sqluser'].'",
					"'.$input['xlrstats_sqlpwd'].'",
					"'.$input['xlrstats_prefix'].'"
				)
			');
		}
		
		
		die (json_encode(array(
			"message" => $tpl->phrase("saving"),
			"href" => "index.php?edit&".Session::sid()
		)));
	}
	
	
	### SERVER SORTIEREN ###
	if ($action == "sort_server") {
		if ($user['adminpower'] != "1") die (json_encode(array("message" => "Error: You have not the required rights to perform this action")));
		
		foreach ($input as $array) {
			$sql->query('
				UPDATE 
					'.$sql->prefix.'server 
				SET 
					`order` = "'.$array['order'].'"
				WHERE 
					`id` = "'.$array['id'].'"
			');
		}
	}
	
	
	### SERVER LSCHEN ###
	if ($action == "delete_server") {
		if ($user['adminpower'] != "1") die (json_encode(array("message" => "Error: You have not the required rights to perform this action")));
		
		$sql->query('DELETE FROM '.$sql->prefix.'server WHERE id = "'.$input.'"');
		
		die (json_encode(array(
			"message" => $tpl->phrase("saving"),
			"href" => "index.php?edit&".Session::sid()
		)));
	}
	
	
	### ALLGEMEINE EINSTELLUNGEN SPEICHERN ###
	if ($action == "settings") {
		if ($user['adminpower'] != "1") die (json_encode(array("message" => "Error: You have not the required rights to perform this action")));
		
		if ($input['name'] == "debug") {
			// Debug-Mode setzen
			$sql_data = json_decode(SQL);
			$handle = fopen('../tmp/sql.php', "w") 
				or die (json_encode(Array("message" => "Error: Failure during writing of file sql.php")));
			
			fwrite($handle, '<?php define (\'SQL\', \' {"debug": "'.$input['value'].'", "sqldb": "'.$sql_data->sqldb.'", "sqlhost": "'.$sql_data->sqlhost.'", "sqluser": "'.$sql_data->sqluser.'", "sqlpwd": "'.$sql_data->sqlpwd.'", "prefix": "'.$sql_data->prefix.'"} \'); ?>');
			fclose($handle);
		}
		
		else {
			if ($input['name'] == "path") {
				$value = $input['value'];
				$value = substr($value, -1)   != "/"       ? $value."/"       : $value;
				$value = substr($value, 0, 7) != "http://" ? "http://".$value : $value;
				$value = $value == "http:///"              ? ""               : $value;
			} else {
				$value = $input['value'];
			}
			$settings->set($input['name'], $value, true);
		}
	}
	
	
	### CMS-PLUGINS ###
	if ($action == "plugins") {
		if ($user['adminpower'] != "1") die (json_encode(array("message" => "Error: You have not the required rights to perform this action")));
		
		$cms = $settings->get("cms");
		$path = $settings->get("path");
		
		// Template laden
		$tpl->load_phrases("manual", true);
		eval ("\$manual = \"".$tpl->template("manual", "html", "plugins/".$cms)."\";");
		$manual = str_ireplace("ezstats2_bf3", "ezstats2_serv", $manual);
		$manual = str_ireplace("ezstats_bf3", "ezstats2_serv", $manual);
		$manual = phpQuery::newDocumentHTML($manual);
		
		die($manual);
	}
	
	
	### STYLE ###
	if ($action == "style") {
		if ($user['adminpower'] != "1") die (json_encode(array("message" => "Error: You have not the required rights to perform this action")));
		
		if ($input == "reset_settings") {
			// Werte zurcksetzen
			if ($defaults = json_decode(@file_get_contents("../tmp/defaults.js"))) {
				$sql->query('TRUNCATE TABLE '.$sql->prefix.'style');
				foreach ($defaults->style as $name => $value) {
					$sql->query('INSERT INTO '.$sql->prefix.'style (name, value) VALUES ("'.$name.'", "'.$value.'")');
				}
			} else {
				die ("Error: Failure during loading of file defaults.js");
			}
		} 
		else if (isset($input['preset'])) {
			// Preset bernehmen
			if ($input['preset'] != "") {
				$presets = json_decode(@file_get_contents("../tmp/styles.js"));
				$presets = $presets->$input['preset'];
				
				foreach ($presets as $name => $value) {
					$sql->query('
						UPDATE 
							'.$sql->prefix.'style 
						SET 
							value = "'.$value.'"
						WHERE 
							name = "'.$name.'"
					');
				}
			} else die();
		}
		else {
			// Werte speichern
			$sql->query('
				UPDATE 
					'.$sql->prefix.'style 
				SET 
					value = "'.$input['value'].'"
				WHERE 
					name = "'.$input['name'].'"
			');
		}
	}
	
	
	### USER HINZUFGEN ###
	if ($action == "add_user") {
		if ($user['adminpower'] != "1") die (json_encode(array("message" => "Error: You have not the required rights to perform this action")));
		
		// berprfen ob alle Werte bergeben wurden
		if (trim($input['username']) == "" OR trim($input['password']) == "") die (json_encode(array("message" => $tpl->phrase("message_no_user_or_pass"))));
		
		// berprfen, ob der Username schon existiert
		$sql->query('SELECT id FROM '.$sql->prefix.'users WHERE name="'.$input['username'].'"');
		if ($sql->count()) die (json_encode(array("message" => $tpl->phrase("message_user_already_added"))));
		
		// Werte speichern
		$sql->query('
			INSERT INTO '.$sql->prefix.'users (
				name, password, adminpower
			) VALUES (
				"'.$input['username'].'", "'.md5($input['password']).'", "'.$input['adminpower'].'"
			)
		');
		
		$name = $input['username'];
		$message = $tpl->phrase("message_user_saved");
		eval ( "\$message = \"$message\";" );
		
		die (json_encode(array("message" => $message, "success" => "1")));
	}
	
	
	### USERLISTE LADEN ###
	if ($action == "load_user") {
		$sql->query('SELECT * FROM '.$sql->prefix.'users ORDER BY id');
		while ($user = $sql->fetchRow()) {
			$adminpower = $user['adminpower'] ? $tpl->phrase("user_full_rights") : $tpl->phrase("user_rcon_only");
			
			echo '<tr>';
				echo '<td>'.$user['name'].'</td>';
				echo '<td>'.$adminpower.'</td>';
			if ($user['id'] != "1")
				echo '<td><a href="#" class="button" action="delete" userid="'.$user['id'].'" username="'.$user['name'].'" delphrase="'.$tpl->phrase('really_delete').'" defphrase="'.$tpl->phrase('delete').'">'.$tpl->phrase('delete').'</a></td>';
			else echo '<td></td>';
			echo '</tr>';
		}
		die();
	}
	
	
	### USER LSCHEN ###
	if ($action == "delete_user") {
		$sql->query('DELETE FROM '.$sql->prefix.'users WHERE (id = "'.$input['id'].'")');
		
		$name = $input['name'];
		$message = $tpl->phrase("message_delete_user");
		eval ( "\$message = \"$message\";" );
		
		die (json_encode(array("message" => $message)));
	}
	
?>