<?php
	### Weiterleitung auf den Installer ###
	if (!file_exists('tmp/sql.php')) {
		header("Status: 301 Moved Permanently");
		header("Location:install/");
		exit; 
	}
	
	
	### Klassen laden ###
	if (true) {
		require 'tmp/sql.php';
		require 'classes/mysql.php';
		
		$sql = new MySQL(); if ($sql->debug) error_reporting (E_ALL|E_STRICT); else error_reporting (0);
		
		require 'plugins/phpQuery.php';
		require 'classes/settings.php';
		require 'classes/security.php';
		require 'classes/functions.php';
		require 'classes/template.php';
		require 'classes/server.php';
		require 'classes/rcon.php';
		
		
		$func     = new Functions();
		$secure   = new Security();
		$settings = new Settings();
		$server   = new Server();
		$tpl      = new Templates();
		$tpl->load_phrases("overview", true);
		$tpl->load_phrases("_serv", true);
	}
	
	
	### Allgemeine Variablen setzen ###
	if (true) {
		$func->counter();                                                      // Counter starten
		$preset = $func->load_settings("settings");                            // Settings laden
		date_default_timezone_set($preset["timezone"]);                        // Zeitzone setzen
		$lastupdate = date("d.m.Y - H:i", $preset["lastcheckall"]);            // Variable fr das letzte Update aller Spieler
		$id = Array();                                                         // Array, indem die IDs der Server gespeichert werden
		$path = ($preset['cms'] == "standalone") ? "" : $preset['path'];       // Pfad zum Skript
		$sql->query('SELECT * FROM '.$sql->prefix.'server ORDER BY `order`');  // Serverdaten abrufen
	}
	
	
	### Serverliste generieren ###
	if ($sql->count() > 1 AND $preset['serv_serverlist']) {
		$showserverlist = "1";
		
		eval ("\$serverlist = \"".$tpl->template("serverlist")."\";");  
		$serverlist = phpQuery::newDocumentHTML($serverlist);
		
		while ($row = $sql->fetchRow()) {
			// ID-Array fllen
			$id[] = $row['id'];
			
			// Icons
			$game     = $preset['serv_gameicon'] ? '<img src="'.$path.'stylesheets/images/icon_'.$row['game'].'.png" width="16" height="16" alt="'.$row['game'].'" />&nbsp;&nbsp;&nbsp;' : "";
			$platform = $preset['serv_platicon'] ? '<img src="'.$path.'stylesheets/images/icon_'.$row['platform'].'.png" width="16" height="16" alt="'.$row['platform'].'" />&nbsp;&nbsp;&nbsp;' : "";
			
			// Name abrufen, falls kein Name in Datenbank gespeichert ist
			if ($row['name'] == "") {
				$server->set($row['id']);
				$server->get();
				
				if ($server->error === false) {
					$row['name'] = $server->info->name;
				} else {
					$row['name'] = $server->error;
				}
			}
			
			// Listenelement in <ul> einhngen
			pq('.ezDropdown')->append('<li><a href="'.$row['id'].'">'.$game.$platform.$row['name'].'</a>');
		}
	} else {
		$showserverlist = "0";
		$serverlist = "";
		$id[] = $sql->fetchRow("id");
	}
	
	
	### Seite erzeugen und ausgeben ###
	if (true) {
		// Template laden
		if ($preset['cms'] == "standalone") {
			eval ("\$html = \"".$tpl->template("standalone")."\";");  $html = phpQuery::newDocumentHTML($html);
		} else {
			eval ("\$html = \"".$tpl->template("plugin")."\";");
			$html = str_replace('#PATH#', $preset['path'], $html);
			$html = phpQuery::newDocumentHTML($html);
		}
		
		
		// Serverliste einbinden / ausblenden
		if ($showserverlist)	pq('#ezCompare')->append($serverlist);
		else					pq('#ezCompare')->attr("style", "display:none");
		
		
		// Postprocessing
		if (!$preset['ov_brand'])            pq('#ezBrand')->remove(); // Werbung entfernen
		if (!$preset['ov_infobox'])          pq('#ezAside')->remove(); // Infobox entfernen
		//if ($preset['language'] == "hebrew") pq('#ezStats')->attr('dir', 'rtl'); // Schriftrichtung ndern bei RTL-Sprachen
		
		
		// Ausgabe
		header('Content-Type:text/html; charset=UTF-8');
		echo $html;
	}
?>